#include <sys/types.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <curl/curl.h>

static size_t	write_function_cb(void *ptr, size_t size, size_t nmemb, void *stream)
{
	ptr = ptr;
	stream = stream;

	return size * nmemb;
}

int	main(int argc, char *argv[])
{
	long	verify_peer;
	long	do_global_init;

	if (3 == argc)
	{
		if (0 != (verify_peer = atol(argv[1])))
			verify_peer = 1L;

		if (0 != (do_global_init = atol(argv[2])))
			do_global_init = 1L;
	}
	else
		abort();

	printf("%d\n", getpid());

	for (;;)
	{
		CURL	*easy_handle;
		char	*url = "https://en.wikipedia.org/wiki/Zabbix";
		int	err;

		if (1L == do_global_init)
			if (CURLE_OK != (err = curl_global_init(CURL_GLOBAL_ALL)))
				abort();

		if (NULL == (easy_handle = curl_easy_init()))
			abort();

		if (CURLE_OK != (err = curl_easy_setopt(easy_handle, CURLOPT_WRITEFUNCTION, write_function_cb)))
			abort();

		if (CURLE_OK != (err = curl_easy_setopt(easy_handle, CURLOPT_HEADERFUNCTION, write_function_cb)))
			abort();

		if (CURLE_OK != (err = curl_easy_setopt(easy_handle, CURLOPT_SSL_VERIFYPEER, verify_peer)))
			abort();

		if (CURLE_OK != (err = curl_easy_setopt(easy_handle, CURLOPT_URL, url)))
			abort();

		if (CURLE_OK != (err = curl_easy_perform(easy_handle)))
			abort();

		curl_easy_cleanup(easy_handle);

		if (1L == do_global_init)
			curl_global_cleanup();

		sleep(1);
	}

	return 0;
}
